Census_NewPlayers = {};
Census = {};
Census_Database = {};

local runTime = 0;
local lastRun = 0;
local delta = .25;

local jobs = {};
local currentNewPlayers = {};

local queryRunning = false;
local currentJob = nil;
local trace = true;
local debug = true;
local startup = true;
local censusOff = false;
local isOrder = false;
--Events

----------------------------------------------------------------
-- Census Startup
----------------------------------------------------------------
function Census.onInitialize()
	
--local status, err = pcall(function()
--	local i = 1
--	while(i < 300) do
--		local name = GetZoneName(i);
--		CensusZoneMap[tostring(GetZoneName(i))] = i;
--		i = i+1;
--	end
--end)
--if(err ~= nil) then
--	Census.err(err);
--end

local status, err = pcall(function() 
		Census.trace("Census.onInitialize");

		Census_Database['censusCount'] = 1;
		Census_Database['error'] = {};
		Census_Database["snapshots"] = {};
		
		Census.MAX_RESULTS = 30;
		Census.setTimestamp();

		for key, data in pairs(EA_Window_WorldMap.campaignZones) do
			table.insert(zone, key);	
		end	

		Census.hook();
		
		RegisterEventHandler(SystemData.Events.SOCIAL_SEARCH_UPDATED, "Census.handleSearchResults" );
	
		Census.trace( "Initialized.  /censusstart /censusstop" );
	end)
	if(err ~= nil) then
		Census.err(err);
	end
end

function Census.setTimestamp()
	local status, err = pcall(function() 
		local lastEntry = TextLogGetNumEntries("Chat") - 1;
		Calendar.SetTodaysDate();
		if(lastEntry > 0) then
	        local lastTime = TextLogGetEntry("Chat", lastEntry);
	        local hours,mins,secs = lastTime:match(L"([0-9]+):([0-9]+):([0-9]+)");
		    Census.Timestamp = Calendar.todaysMonth .. "-" .. Calendar.todaysDay .. "-" .. Calendar.todaysYear .. " " ..  tostring(hours) .. ":" .. tostring(mins) .. ":" .. tostring(secs); 
	    end
	end)
	if(err ~= nil) then
		Census.err(err);
	end
end

----------------------------------------------------------------
-- Census Update
----------------------------------------------------------------
function Census.onUpdate(interval)
	local status, err = pcall(function() 
		if(censusOff == true) then
			return;
		end
		Census.setTimestamp();
		runTime = (interval / 60.0) + runTime;
		if(lastRun == nil or (runTime - lastRun > delta)) then
			if(not queryRunning) then
				lastRun = runTime;
				queryRunning = true;
				if(#jobs == 0) then
					if(startup == true) then
						startup = false;
						Census_Database["snapshots"][Census_Database['censusCount']] = {};
						Census_Database["snapshots"][Census_Database['censusCount']]['start'] = Census.Timestamp;
					else
						Census_NewPlayers = currentNewPlayers;		
						Census.debug(#Census_NewPlayers .. " player(s) in Census_NewPlayers list");
						currentNewPlayers = {};		

						Census_Database["snapshots"][Census_Database['censusCount']]['stop'] = Census.Timestamp;

						Census_Database['censusCount'] = Census_Database['censusCount']+1;

						Census_Database["snapshots"][Census_Database['censusCount']] = {};
						Census_Database["snapshots"][Census_Database['censusCount']]['start'] = Census.Timestamp;
					end
					Census.seedCensus();
				end
				Census.runCensus();
			end
		end
	end)
	if(err ~= nil) then
		Census.err(err);
	end
end

----------------------------------------------------------------
-- Census Shutdown
----------------------------------------------------------------
function Census.onShutdown()
	Census.trace("Census.onShutdown");
	Census.unhook();
end

--Interface hooks

----------------------------------------------------------------
-- CensusWindow Functions
----------------------------------------------------------------
function Census.hook()
	Census.trace("Census.hook");
    Census.onKeyEnterOrig = EA_ChatWindow.OnKeyEnter;
    EA_ChatWindow.OnKeyEnter = Census.onKeyEnter;	
end

----------------------------------------------------------------
-- CensusWindow Functions
----------------------------------------------------------------
function Census.unhook()
	Census.trace("Census.unhook");
	if(Census.OnKeyEnterTramp) then
		EA_ChatWindow.OnKeyEnter = Census.onKeyEnterOrig;
		Census.onKeyEnterOrig = nil;		
	end
end

----------------------------------------------------------------
-- Census Command Line Functions
----------------------------------------------------------------
function Census.onKeyEnter(...)
	Census.trace("Census.onKeyEnter");
	local wsCommand = EA_TextEntryGroupEntryBoxTextInput.Text;
	wsCommand = wstring.lower(wsCommand);
	
	if(wsCommand == L"/censusstop") then
		Census_Database["snapshots"][Census_Database['censusCount']] = nil;
		censusOff = true;
		startup = true;
		jobs = {};
		EA_TextEntryGroupEntryBoxTextInput.Text = L"";
	end
	if(wsCommand == L"/censusstart") then
		censusOff = false;
		EA_TextEntryGroupEntryBoxTextInput.Text = L"";
	end

	Census.onKeyEnterOrig(...);
end

--Census functionality

function Census.seedCensus()
	Census.trace("Census.seedCensus");
	local zone = {};
	zone[1] = -1;
	table.insert(jobs, Census.createJob(nil, nil, nil, zone, 1, 5));
	table.insert(jobs, Census.createJob(nil, nil, nil, zone, 6, 10));
	table.insert(jobs, Census.createJob(nil, nil, nil, zone, 11, 15));
	table.insert(jobs, Census.createJob(nil, nil, nil, zone, 16, 20));
	table.insert(jobs, Census.createJob(nil, nil, nil, zone, 21, 25));
	table.insert(jobs, Census.createJob(nil, nil, nil, zone, 26, 30));
	table.insert(jobs, Census.createJob(nil, nil, nil, zone, 31, 35));
	table.insert(jobs, Census.createJob(nil, nil, nil, zone, 36, 39));
	Census.subDivide(Census.createJob(nil, nil, nil, zone, 40, 40));
end

function Census.createJob(name, guild, career, zone, minLevel, maxLevel)
	Census.trace("Census.createJob");
	local retVal = {};

	retVal.name = name;
	retVal.guild = guild;
	retVal.career = career;
	retVal.zone = zone;
	retVal.minLevel = minLevel;
	retVal.maxLevel = maxLevel;
	
	if(name == nil) then
		retVal.name = L"";
	end	
	if(guild == nil) then
		retVal.guild = L"";
	end	
	if(career == nil) then
		retVal.career = L"";
	end	

	return retVal;
end

function Census.runCensus() 
	local status, err = pcall(function() 
		Census.trace("Census.runCensus");
		if(#jobs > 0) then
			local job = jobs[1];
			currentJob = job;
			table.remove(jobs, 1);
			Census.debugJob(job);			
			SendPlayerSearchRequest( job.name, job.guild, job.career, job.zone, job.minLevel, job.maxLevel );
		end
	end);
	if(err ~= nil) then
		Census.err(err);
	end
end

function Census.handleSearchResults() 
	local status, err = pcall(function() 
		Census.trace("Census.handleSearchResults");
		if(censusOff == true) then
			return;
		end
		local numResults = #SocialWindowTabSearch.playerListData;
		Census.trace(numResults .. " result(s) returned from query");
		local cont = true;
		if(numResults == Census.MAX_RESULTS) then
			--If there is nothing else to divide on, process the 30 hits and move on. 
			local divideSuccess = Census.subDivide(currentJob);
			if(divideSuccess) then
				cont = false; 
			end
		end
		if(cont) then
			if(numResults ~= 0) then
				local currentCensus = Census_Database['censusCount'];
				for key, playerData in pairs( SocialWindowTabSearch.playerListData ) do
					key = playerData['name'];
					key = tostring(key);
					
					if(key == "No Results") then
						Census.trace("No results found! Moving on");
						break;
					end
					local ignore = false;
					if(currentJob ~= nil and currentJob.name ~= nil and currentJob.name ~= L"") then
						if(not Census.startsWith(string.lower(tostring(key)), string.lower(tostring(currentJob.name)))) then
							ignore = true;
						end 
					end
					if(not ignore) then
						if(currentCensus ~= 1) then
							if(Census_Database["snapshots"][currentCensus-1]['seen'][key] == nil) then
								Census.addUnique(playerData['name'], currentNewPlayers);
								Census.debug("Number of currentNewPlayers is " .. #currentNewPlayers);
							end
						end
						if(Census_Database["snapshots"][currentCensus]['seen'] == nil) then
							Census_Database["snapshots"][currentCensus]['seen'] = {};
						end
						Census_Database["snapshots"][currentCensus]['seen'][key] = 1;
						for data, dataValue in pairs(playerData) do
							if(Census_Database["snapshots"][currentCensus]['data'] == nil) then
								Census_Database["snapshots"][currentCensus]['data'] = {};
							end
							if(Census_Database["snapshots"][currentCensus]['data'][key] == nil) then
								Census_Database["snapshots"][currentCensus]['data'][key] = {};
							end
							Census_Database["snapshots"][currentCensus]['data'][key][data] = dataValue;
						end
					end
				end
			end
		end		
		currentJob = nil;
		queryRunning = false;
	end);
	if(err ~= nil) then
		Census.err(err);
	end
end

function Census.subDivide(job)
	
	if(job.name ~= nil) then
		Census.debug("name:");
		Census.debug(job.name);
	end	
	if(job.guild ~= nil) then
		Census.debug("guild:");
		Census.debug(job.guild);
	end	
	if(job.career ~= nil) then
		Census.debug("career:");
		Census.debug(job.career);
	end	
	
	Census.debug("zone:" .. job.zone[1]);
	
	Census.trace("Census.subDivide");
	if(job.minLevel ~= job.maxLevel) then
		Census.fillLevel(job);
	elseif(job.career == L"") then
		Census.fillClass(job);
	elseif (job.zone[1] == -1) then
		Census.fillZone(job);
	elseif(job.name == L"") then
		Census.fillName(job);
	else
		Census.err("Ran out of things to subdivide on!");
		return false;
	end
	
	return true;
end

function Census.fillName(job)
	Census.trace("Subdividing on name");
	for i, value in ipairs(nameLetters) do
		table.insert(jobs, 1, Census.createJob(value, job.guild, job.career, job.zone, job.minLevel, job.maxLevel));	
	end
end

function Census.fillZone(job)
	Census.trace("Subdividing on zone");
	for i, value in ipairs(zone) do
		local zone = {};
		zone[1] = value;
		table.insert(jobs, 1, Census.createJob(job.name, job.guild, job.career, zone, job.minLevel, job.maxLevel));	
	end
end

function Census.fillLevel(job)
	Census.trace("Subdividing on level");
	for i=job.minLevel,job.maxLevel do
		table.insert(jobs, 1, Census.createJob(job.name, job.guild, job.career, job.zone, i, i));
	end
end


function Census.fillClass(job)
	Census.trace("Subdividing on class");
	local classNames = nil;
	if(isOrder) then
		classNames = class.order;
	else
		classNames = class.destruction;
	end
	for i, value in ipairs(classNames) do
		table.insert(jobs, 1, Census.createJob(job.name, job.guild, value, job.zone, job.minLevel, job.maxLevel));	
	end
end
	

--Util

function Census.addUnique(value, list) 
	for i, currentValue in ipairs(list) do
		if(value == currentValue) then
			return;
		end
	end
	list[#list+1] = value;
end

-----------------------------------------------------------------------------------
--
-- Census debug messages
--
-----------------------------------------------------------------------------------
function Census.trace( msg )
	if(trace) then
		EA_ChatWindow.Print( L"[Census][trace]: " .. towstring(tostring(msg)), ChatSettings.Channels[SystemData.ChatLogFilters.CHANNEL_5].id);
	end
end

function Census.debug( msg )
	if(debug) then
		EA_ChatWindow.Print( L"[Census][debug]: " .. towstring(tostring(msg)), ChatSettings.Channels[SystemData.ChatLogFilters.CHANNEL_6].id);
	end
end

function Census.err( msg )
	table.insert(Census_Database['error'], msg);
	EA_ChatWindow.Print( L"[Census][error]: " .. towstring(tostring(msg)), ChatSettings.Channels[SystemData.ChatLogFilters.CHANNEL_9].id);
end

function Census.debugJob(job)
	Census.trace("SendPlayerSearchRequest( "..tostring(job.name)..", "..tostring(job.guild)..", "..tostring(job.career)..", "..job.zone[1]..", "..job.minLevel..", "..job.maxLevel.." )");
end

function Census.startsWith(toCheck,fragment)
   return string.sub(toCheck,1,string.len(fragment))==fragment;
end

